/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-10.2.1-20200826/gcc/config/m32r/m32r.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 26 "../../gcc-10.2.1-20200826/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 32 "../../gcc-10.2.1-20200826/gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 41 "../../gcc-10.2.1-20200826/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 43 "../../gcc-10.2.1-20200826/gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 50 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 51 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 57 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 58 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 62 "../../gcc-10.2.1-20200826/gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 66 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONSTANT_P (op))) && (
#line 67 "../../gcc-10.2.1-20200826/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 71 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONSTANT_P (op))) && ((
#line 72 "../../gcc-10.2.1-20200826/gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 73 "../../gcc-10.2.1-20200826/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 77 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 78 "../../gcc-10.2.1-20200826/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 82 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 83 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 89 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 90 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 95 "../../gcc-10.2.1-20200826/gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_I (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 56 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(ival >= -0x80 && ival <= 0x7f));
}
static inline bool
satisfies_constraint_J (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 61 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(ival >= -0x8000 && ival <= 0x7fff));
}
static inline bool
satisfies_constraint_K (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 66 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
((unsigned HOST_WIDE_INT) ival <= 0x0000ffff));
}
static inline bool
satisfies_constraint_L (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 71 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
((ival & 0xffff) == 0)) && (
#line 72 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
((ival >> 16) >= -0x8000 && (ival >> 16) <= 0x7fff)));
}
static inline bool
satisfies_constraint_M (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 77 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
((unsigned HOST_WIDE_INT) ival <= 0x00ffffff));
}
static inline bool
satisfies_constraint_N (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 82 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(ival >= -127 && ival <= 128));
}
static inline bool
satisfies_constraint_O (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 87 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(ival >= 0 && ival < 32));
}
static inline bool
satisfies_constraint_P (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 92 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(ival >= -0x7fff && ival <= 0x8000));
}
static inline bool
satisfies_constraint_G (rtx op)
{
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 98 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(easy_di_const (op)));
}
static inline bool
satisfies_constraint_H (rtx op)
{
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 103 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(easy_df_const (op)));
}
static inline bool
satisfies_constraint_Q (rtx op)
{
  return ((
#line 108 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(TARGET_ADDR24)) && (
#line 109 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(GET_CODE (op) == LABEL_REF))) || (
#line 110 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(addr24_operand (op, VOIDmode)));
}
static inline bool
satisfies_constraint_R (rtx op)
{
  return ((
#line 114 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(TARGET_ADDR32)) && (
#line 115 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(GET_CODE (op) == LABEL_REF))) || (
#line 116 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(addr32_operand (op, VOIDmode)));
}
static inline bool
satisfies_constraint_S (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && ((
#line 121 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(mode == SImode || mode == SFmode)) && ((GET_CODE (XEXP (op, 0)) == PRE_INC || GET_CODE (XEXP (op, 0)) == PRE_DEC) && ((GET_CODE (XEXP (XEXP (op, 0), 0)) == REG) && (
#line 124 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(GPR_P (REGNO (XEXP (XEXP (op, 0), 0)))
		    || REGNO (XEXP (XEXP (op, 0), 0)) == ARG_POINTER_REGNUM
		    || ! HARD_REGISTER_P (XEXP (XEXP (op, 0), 0)))))));
}
static inline bool
satisfies_constraint_T (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 131 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(memreg_operand (op, GET_MODE (op))));
}
static inline bool
satisfies_constraint_U (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && ((
#line 136 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(mode == SImode || mode == SFmode)) && ((GET_CODE (XEXP (op, 0)) == POST_INC) && ((GET_CODE (XEXP (XEXP (op, 0), 0)) == REG) && (
#line 139 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(GPR_P (REGNO (XEXP (XEXP (op, 0), 0)))
		    || REGNO (XEXP (XEXP (op, 0), 0)) == ARG_POINTER_REGNUM
		    || ! HARD_REGISTER_P (XEXP (XEXP (op, 0), 0)))))));
}
static inline bool
satisfies_constraint_W (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 146 "../../gcc-10.2.1-20200826/gcc/config/m32r/constraints.md"
(ival == 0));
}
#endif /* tm-constrs.h */
