/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 86:  /* atomic_compare_and_swapsi */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (pat, 0, 2));
      ro[3] = *(ro_loc[3] = &XVECEXP (pat, 0, 3));
      ro[4] = *(ro_loc[4] = &XVECEXP (pat, 0, 4));
      ro[5] = *(ro_loc[5] = &XVECEXP (pat, 0, 5));
      ro[6] = *(ro_loc[6] = &XVECEXP (pat, 0, 6));
      ro[7] = *(ro_loc[7] = &XVECEXP (pat, 0, 7));
      ro[8] = *(ro_loc[8] = &XEXP (XVECEXP (pat, 0, 8), 0));
      break;

    case 84:  /* set_text */
    case 83:  /* set_got */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 80:  /* call_value_intern */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 79:  /* call_value_intern_plt */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 78:  /* call_internal1 */
    case 77:  /* call_internal_plt */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 75:  /* simple_return_internal */
    case 74:  /* return_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 82:  /* trap */
    case 81:  /* nop */
    case 76:  /* blockage */
    case 73:  /* *simple_return */
    case 72:  /* *return */
      break;

    case 71:  /* *microblaze.md:1881 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 70:  /* tablejump_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 69:  /* indirect_jump_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 68:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 67:  /* branch_compare */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      break;

    case 66:  /* branch_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 65:  /* cstoresf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 46:  /* *movdf_internal */
    case 45:  /* *movsf_internal */
    case 43:  /* *movqi_internal2 */
    case 42:  /* *movhi_internal2 */
    case 41:  /* *movsi_internal2 */
    case 40:  /* *movsi_internal5_pltop */
    case 39:  /* *movsi_internal3 */
    case 38:  /* movsi_status */
    case 37:  /* *movdi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 21:  /* *usmulsi3_highpart */
    case 20:  /* *umulsi3_highpart */
    case 19:  /* *smulsi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 18:  /* usmulsidi3 */
    case 17:  /* umulsidi3 */
    case 16:  /* mulsidi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 13:  /* iprefetch */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      break;

    case 64:  /* sne_internal_pat */
    case 63:  /* seq_internal_pat */
    case 62:  /* *lshrsi_reg */
    case 61:  /* *lshrsi_inline */
    case 60:  /* *lshrsi3_bshift */
    case 59:  /* *lshrsi3_byone */
    case 58:  /* *ashrsi_reg */
    case 57:  /* *ashrsi_inline */
    case 56:  /* *ashrsi3_bshift */
    case 55:  /* *ashrsi3_byone */
    case 54:  /* *ashlsi_reg */
    case 53:  /* *ashlsi_inline */
    case 52:  /* *ashlsi3_with_rotate */
    case 51:  /* *ashlsi3_with_size_opt */
    case 50:  /* *ashlsi3_with_mul_nodelay */
    case 49:  /* *ashlsi3_with_mul_delay */
    case 48:  /* ashlsi3_bshift */
    case 47:  /* *ashlsi3_byone */
    case 30:  /* xorsi3 */
    case 29:  /* iorsi3 */
    case 28:  /* andsi3 */
    case 23:  /* udivsi3 */
    case 22:  /* divsi3_internal */
    case 15:  /* mulsi3 */
    case 14:  /* subdi3 */
    case 12:  /* subsi3 */
    case 11:  /* adddi3 */
    case 10:  /* addsi3 */
    case 6:  /* divsf3 */
    case 5:  /* mulsf3 */
    case 4:  /* subsf3 */
    case 3:  /* addsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 85:  /* clzsi2 */
    case 44:  /* movsi4_rev */
    case 36:  /* extendsidi2 */
    case 35:  /* extendhisi2 */
    case 34:  /* extendqisi2 */
    case 33:  /* zero_extendqisi2 */
    case 32:  /* zero_extendqihi2 */
    case 31:  /* zero_extendhisi2 */
    case 27:  /* *one_cmpldi2 */
    case 26:  /* one_cmplsi2 */
    case 25:  /* negdi2 */
    case 24:  /* negsi2 */
    case 9:  /* fix_truncsfsi2 */
    case 8:  /* floatsisf2 */
    case 7:  /* sqrtsf2 */
    case 2:  /* bswaphi2 */
    case 1:  /* bswapsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    }
}
