/* Generated automatically by the program `genpeep'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "tree.h"
#include "rtl.h"
#include "insn-config.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "regs.h"
#include "output.h"
#include "recog.h"
#include "except.h"
#include "diagnostic-core.h"
#include "flags.h"
#include "tm-constrs.h"

extern rtx peep_operand[];

#define operands peep_operand

rtx_insn *
peephole (rtx_insn *ins1)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;
  rtx x ATTRIBUTE_UNUSED, pat ATTRIBUTE_UNUSED;

  if (NEXT_INSN (ins1)
      && BARRIER_P (NEXT_INSN (ins1)))
    return 0;

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3152;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3152;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3152;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3152; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3152;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3152;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L3152;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3152;
  if (GET_MODE (x) != V16QImode) goto L3152;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3152;
  if (GET_MODE (x) != SImode) goto L3152;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3152;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3152;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3152;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3152;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3152:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3153;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3153;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3153;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3153; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3153;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3153;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L3153;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3153;
  if (GET_MODE (x) != V16QImode) goto L3153;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3153;
  if (GET_MODE (x) != DImode) goto L3153;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3153;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3153;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3153;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3153;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3153:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3154;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3154;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3154;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3154; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3154;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3154;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L3154;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3154;
  if (GET_MODE (x) != V8HImode) goto L3154;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3154;
  if (GET_MODE (x) != SImode) goto L3154;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3154;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3154;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3154;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3154;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3154:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3155;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3155;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3155;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3155; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3155;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3155;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L3155;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3155;
  if (GET_MODE (x) != V8HImode) goto L3155;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3155;
  if (GET_MODE (x) != DImode) goto L3155;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3155;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3155;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3155;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3155;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3155:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3156;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3156;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3156;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3156; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3156;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3156;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L3156;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3156;
  if (GET_MODE (x) != V4SImode) goto L3156;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3156;
  if (GET_MODE (x) != SImode) goto L3156;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3156;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3156;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3156;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3156;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3156:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3157;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3157;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3157;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3157; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3157;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3157;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L3157;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3157;
  if (GET_MODE (x) != V4SImode) goto L3157;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3157;
  if (GET_MODE (x) != DImode) goto L3157;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3157;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3157;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3157;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3157;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3157:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3158;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3158;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3158;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3158; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3158;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3158;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L3158;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3158;
  if (GET_MODE (x) != V2DImode) goto L3158;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3158;
  if (GET_MODE (x) != SImode) goto L3158;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3158;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3158;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3158;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3158;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3158:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3159;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3159;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3159;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3159; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3159;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3159;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L3159;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3159;
  if (GET_MODE (x) != V2DImode) goto L3159;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3159;
  if (GET_MODE (x) != DImode) goto L3159;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3159;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3159;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3159;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3159;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3159:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3160;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3160;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3160;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3160; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3160;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3160;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L3160;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3160;
  if (GET_MODE (x) != V4SFmode) goto L3160;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3160;
  if (GET_MODE (x) != SImode) goto L3160;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3160;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3160;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3160;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3160;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3160:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3161;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3161;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3161;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3161; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3161;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3161;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L3161;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3161;
  if (GET_MODE (x) != V4SFmode) goto L3161;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3161;
  if (GET_MODE (x) != DImode) goto L3161;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3161;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3161;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3161;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3161;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3161:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3162;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3162;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3162;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3162; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3162;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3162;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L3162;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3162;
  if (GET_MODE (x) != V2DFmode) goto L3162;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3162;
  if (GET_MODE (x) != SImode) goto L3162;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3162;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3162;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3162;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3162;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3162:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3163;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3163;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3163;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3163; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3163;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3163;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L3163;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3163;
  if (GET_MODE (x) != V2DFmode) goto L3163;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3163;
  if (GET_MODE (x) != DImode) goto L3163;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3163;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3163;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3163;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3163;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3163:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3164;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3164;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3164;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3164; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3164;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3164;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L3164;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3164;
  if (GET_MODE (x) != V1TImode) goto L3164;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3164;
  if (GET_MODE (x) != SImode) goto L3164;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3164;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3164;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3164;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3164;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3164:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3165;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3165;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3165;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3165; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3165;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3165;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L3165;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3165;
  if (GET_MODE (x) != V1TImode) goto L3165;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3165;
  if (GET_MODE (x) != DImode) goto L3165;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3165;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3165;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3165;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3165;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3165:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3166;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3166;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3166;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3166; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3166;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3166;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, KFmode)) goto L3166;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3166;
  if (GET_MODE (x) != KFmode) goto L3166;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3166;
  if (GET_MODE (x) != SImode) goto L3166;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3166;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3166;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L3166;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3166;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3166:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3167;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3167;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3167;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3167; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3167;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3167;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, KFmode)) goto L3167;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3167;
  if (GET_MODE (x) != KFmode) goto L3167;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3167;
  if (GET_MODE (x) != DImode) goto L3167;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3167;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3167;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L3167;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3167;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3167:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3168;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3168;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3168;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3168; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3168;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3168;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TFmode)) goto L3168;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3168;
  if (GET_MODE (x) != TFmode) goto L3168;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3168;
  if (GET_MODE (x) != SImode) goto L3168;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3168;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3168;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L3168;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3168;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3168:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3169;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3169;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3169;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3169; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3169;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3169;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TFmode)) goto L3169;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3169;
  if (GET_MODE (x) != TFmode) goto L3169;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3169;
  if (GET_MODE (x) != DImode) goto L3169;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3169;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3169;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L3169;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3169;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3169:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3170;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3170;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3170;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3170; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3170;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3170;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L3170;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3170;
  if (GET_MODE (x) != TImode) goto L3170;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3170;
  if (GET_MODE (x) != SImode) goto L3170;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3170;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3170;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3170;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3170;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3170:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3171;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3171;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3171;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3171; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3171;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3171;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L3171;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3171;
  if (GET_MODE (x) != TImode) goto L3171;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3171;
  if (GET_MODE (x) != DImode) goto L3171;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3171;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3171;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3171;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3171;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3171:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3172;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3172;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3172;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3172; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3172;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3172;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L3172;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3172;
  if (GET_MODE (x) != V16QImode) goto L3172;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3172;
  if (GET_MODE (x) != SImode) goto L3172;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3172;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3172;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3172;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3172;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3172:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3173;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3173;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3173;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3173; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3173;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3173;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L3173;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3173;
  if (GET_MODE (x) != V16QImode) goto L3173;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3173;
  if (GET_MODE (x) != DImode) goto L3173;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3173;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3173;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3173;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3173;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3173:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3174;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3174;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3174;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3174; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3174;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3174;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L3174;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3174;
  if (GET_MODE (x) != V8HImode) goto L3174;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3174;
  if (GET_MODE (x) != SImode) goto L3174;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3174;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3174;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3174;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3174;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3174:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3175;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3175;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3175;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3175; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3175;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3175;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L3175;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3175;
  if (GET_MODE (x) != V8HImode) goto L3175;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3175;
  if (GET_MODE (x) != DImode) goto L3175;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3175;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3175;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3175;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3175;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3175:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3176;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3176;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3176;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3176; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3176;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3176;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L3176;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3176;
  if (GET_MODE (x) != V4SImode) goto L3176;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3176;
  if (GET_MODE (x) != SImode) goto L3176;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3176;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3176;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3176;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3176;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3176:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3177;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3177;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3177;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3177; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3177;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3177;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L3177;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3177;
  if (GET_MODE (x) != V4SImode) goto L3177;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3177;
  if (GET_MODE (x) != DImode) goto L3177;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3177;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3177;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3177;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3177;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3177:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3178;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3178;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3178;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3178; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3178;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3178;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L3178;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3178;
  if (GET_MODE (x) != V2DImode) goto L3178;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3178;
  if (GET_MODE (x) != SImode) goto L3178;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3178;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3178;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3178;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3178;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3178:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3179;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3179;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3179;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3179; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3179;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3179;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L3179;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3179;
  if (GET_MODE (x) != V2DImode) goto L3179;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3179;
  if (GET_MODE (x) != DImode) goto L3179;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3179;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3179;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3179;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3179;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3179:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3180;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3180;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3180;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3180; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3180;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3180;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L3180;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3180;
  if (GET_MODE (x) != V4SFmode) goto L3180;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3180;
  if (GET_MODE (x) != SImode) goto L3180;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3180;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3180;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3180;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3180;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3180:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3181;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3181;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3181;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3181; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3181;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3181;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L3181;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3181;
  if (GET_MODE (x) != V4SFmode) goto L3181;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3181;
  if (GET_MODE (x) != DImode) goto L3181;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3181;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3181;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3181;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3181;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3181:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3182;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3182;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3182;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3182; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3182;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3182;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L3182;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3182;
  if (GET_MODE (x) != V2DFmode) goto L3182;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3182;
  if (GET_MODE (x) != SImode) goto L3182;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3182;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3182;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3182;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3182;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3182:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3183;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3183;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3183;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3183; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3183;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3183;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L3183;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3183;
  if (GET_MODE (x) != V2DFmode) goto L3183;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3183;
  if (GET_MODE (x) != DImode) goto L3183;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3183;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3183;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3183;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3183;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3183:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3184;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3184;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3184;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3184; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3184;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3184;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L3184;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3184;
  if (GET_MODE (x) != V1TImode) goto L3184;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3184;
  if (GET_MODE (x) != SImode) goto L3184;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3184;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3184;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3184;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3184;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3184:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3185;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3185;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3185;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3185; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3185;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3185;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L3185;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3185;
  if (GET_MODE (x) != V1TImode) goto L3185;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3185;
  if (GET_MODE (x) != DImode) goto L3185;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3185;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3185;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3185;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3185;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3185:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3186;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3186;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3186;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3186; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3186;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3186;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, KFmode)) goto L3186;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3186;
  if (GET_MODE (x) != KFmode) goto L3186;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3186;
  if (GET_MODE (x) != SImode) goto L3186;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3186;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3186;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L3186;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3186;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3186:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3187;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3187;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3187;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3187; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3187;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3187;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, KFmode)) goto L3187;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3187;
  if (GET_MODE (x) != KFmode) goto L3187;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3187;
  if (GET_MODE (x) != DImode) goto L3187;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3187;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3187;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L3187;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3187;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3187:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3188;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3188;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3188;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3188; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3188;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3188;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TFmode)) goto L3188;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3188;
  if (GET_MODE (x) != TFmode) goto L3188;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3188;
  if (GET_MODE (x) != SImode) goto L3188;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3188;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3188;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L3188;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3188;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3188:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3189;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3189;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3189;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3189; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3189;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3189;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TFmode)) goto L3189;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3189;
  if (GET_MODE (x) != TFmode) goto L3189;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3189;
  if (GET_MODE (x) != DImode) goto L3189;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3189;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3189;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L3189;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3189;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3189:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3190;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3190;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3190;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3190; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3190;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3190;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L3190;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3190;
  if (GET_MODE (x) != TImode) goto L3190;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3190;
  if (GET_MODE (x) != SImode) goto L3190;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3190;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3190;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3190;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3190;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3190:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3191;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3191;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3191;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3191; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3191;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3191;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L3191;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3191;
  if (GET_MODE (x) != TImode) goto L3191;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3191;
  if (GET_MODE (x) != DImode) goto L3191;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3191;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3191;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3191;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3191;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3191:

  return 0;
}

rtx peep_operand[4];
