/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 536:  /* atomic_fetch_and_baredi */
    case 535:  /* atomic_fetch_or_baredi */
    case 534:  /* atomic_fetch_add_baredi */
    case 533:  /* atomic_fetch_and_baresi */
    case 532:  /* atomic_fetch_or_baresi */
    case 531:  /* atomic_fetch_add_baresi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 530:  /* atomic_exchange_baredi */
    case 529:  /* atomic_exchange_baresi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 528:  /* atomic_compare_and_swap_baredi */
    case 527:  /* atomic_compare_and_swap_baresi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 526:  /* mtspr_cmpexchdi */
    case 525:  /* mtspr_cmpexchsi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 524:  /* stack_protect_testdi */
    case 523:  /* stack_protect_testsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 522:  /* stack_protect_setdi */
    case 521:  /* stack_protect_setsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 520:  /* *netreg_adddi_from_network */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 519:  /* *netreg_adddi_to_network */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XVECEXP (pat, 0, 0), 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XVECEXP (pat, 0, 0), 0, 1), 1));
      break;

    case 515:  /* insn_wh64 */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      break;

    case 514:  /* *insn_v2sadu */
    case 512:  /* *insn_v2sads */
    case 503:  /* *insn_v1sadu */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 1));
      break;

    case 487:  /* vec_pack_hipart_v4hi */
    case 484:  /* vec_widen_smult_lo_v4qi */
    case 483:  /* vec_widen_usmult_lo_v8qi */
    case 482:  /* vec_widen_umult_lo_v8qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      break;

    case 481:  /* insn_mz_v4hi */
    case 479:  /* insn_mz_v8qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 420:  /* *insn_stnt4_add */
    case 419:  /* *insn_stnt4_add_32bit */
    case 418:  /* *insn_stnt2_add */
    case 417:  /* *insn_stnt2_add_32bit */
    case 416:  /* *insn_stnt1_add */
    case 415:  /* *insn_stnt1_add_32bit */
    case 411:  /* insn_stnt_add */
    case 410:  /* insn_stnt_add_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0), 0, 0);
      recog_data.dup_num[0] = 3;
      break;

    case 414:  /* *insn_stnt4 */
    case 413:  /* *insn_stnt2 */
    case 412:  /* *insn_stnt1 */
    case 409:  /* insn_stnt */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XEXP (pat, 0), 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 408:  /* *insn_st4_add */
    case 407:  /* *insn_st4_add_32bit */
    case 406:  /* *insn_st2_add */
    case 405:  /* *insn_st2_add_32bit */
    case 404:  /* *insn_st1_add */
    case 403:  /* *insn_st1_add_32bit */
    case 402:  /* insn_st_add */
    case 401:  /* insn_st_add_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0);
      recog_data.dup_num[0] = 3;
      break;

    case 518:  /* *netreg_send */
    case 363:  /* insn_mtspr */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 1));
      break;

    case 517:  /* *netreg_receive */
    case 362:  /* insn_mfspr */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      break;

    case 361:  /* insn_lnk */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 360:  /* insn_ldnt4u_add_miss */
    case 359:  /* insn_ldnt4s_add_miss */
    case 358:  /* insn_ldnt4u_add_miss_32bit */
    case 357:  /* insn_ldnt4s_add_miss_32bit */
    case 356:  /* insn_ldnt2u_add_miss */
    case 355:  /* insn_ldnt2s_add_miss */
    case 354:  /* insn_ldnt2u_add_miss_32bit */
    case 353:  /* insn_ldnt2s_add_miss_32bit */
    case 352:  /* insn_ldnt1u_add_miss */
    case 351:  /* insn_ldnt1s_add_miss */
    case 350:  /* insn_ldnt1u_add_miss_32bit */
    case 349:  /* insn_ldnt1s_add_miss_32bit */
    case 315:  /* insn_ldnt4u_add_L2 */
    case 314:  /* insn_ldnt4s_add_L2 */
    case 313:  /* insn_ldnt4u_add_L2_32bit */
    case 312:  /* insn_ldnt4s_add_L2_32bit */
    case 311:  /* insn_ldnt2u_add_L2 */
    case 310:  /* insn_ldnt2s_add_L2 */
    case 309:  /* insn_ldnt2u_add_L2_32bit */
    case 308:  /* insn_ldnt2s_add_L2_32bit */
    case 307:  /* insn_ldnt1u_add_L2 */
    case 306:  /* insn_ldnt1s_add_L2 */
    case 305:  /* insn_ldnt1u_add_L2_32bit */
    case 304:  /* insn_ldnt1s_add_L2_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0, 0), 0, 0), 0);
      recog_data.dup_num[0] = 3;
      break;

    case 348:  /* insn_ldnt4u_miss */
    case 347:  /* insn_ldnt4s_miss */
    case 346:  /* insn_ldnt2u_miss */
    case 345:  /* insn_ldnt2s_miss */
    case 344:  /* insn_ldnt1u_miss */
    case 343:  /* insn_ldnt1s_miss */
    case 303:  /* insn_ldnt4u_L2 */
    case 302:  /* insn_ldnt4s_L2 */
    case 301:  /* insn_ldnt2u_L2 */
    case 300:  /* insn_ldnt2s_L2 */
    case 299:  /* insn_ldnt1u_L2 */
    case 298:  /* insn_ldnt1s_L2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0), 0, 0), 0));
      break;

    case 342:  /* insn_ldnt_add_miss */
    case 341:  /* insn_ldnt_add_miss_32bit */
    case 297:  /* insn_ldnt_add_L2 */
    case 296:  /* insn_ldnt_add_L2_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0, 0), 0);
      recog_data.dup_num[0] = 3;
      break;

    case 340:  /* insn_ldnt_miss */
    case 295:  /* insn_ldnt_L2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0, 0), 0));
      break;

    case 321:  /* insn_ldna_add_miss */
    case 320:  /* insn_ldna_add_miss_32bit */
    case 276:  /* insn_ldna_add_L2 */
    case 275:  /* insn_ldna_add_L2_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0), 0);
      recog_data.dup_num[0] = 3;
      break;

    case 319:  /* insn_ldna_miss */
    case 274:  /* insn_ldna_L2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 0));
      break;

    case 339:  /* insn_ld4u_add_miss */
    case 338:  /* insn_ld4s_add_miss */
    case 337:  /* insn_ld4u_add_miss_32bit */
    case 336:  /* insn_ld4s_add_miss_32bit */
    case 335:  /* insn_ld2u_add_miss */
    case 334:  /* insn_ld2s_add_miss */
    case 333:  /* insn_ld2u_add_miss_32bit */
    case 332:  /* insn_ld2s_add_miss_32bit */
    case 331:  /* insn_ld1u_add_miss */
    case 330:  /* insn_ld1s_add_miss */
    case 329:  /* insn_ld1u_add_miss_32bit */
    case 328:  /* insn_ld1s_add_miss_32bit */
    case 294:  /* insn_ld4u_add_L2 */
    case 293:  /* insn_ld4s_add_L2 */
    case 292:  /* insn_ld4u_add_L2_32bit */
    case 291:  /* insn_ld4s_add_L2_32bit */
    case 290:  /* insn_ld2u_add_L2 */
    case 289:  /* insn_ld2s_add_L2 */
    case 288:  /* insn_ld2u_add_L2_32bit */
    case 287:  /* insn_ld2s_add_L2_32bit */
    case 286:  /* insn_ld1u_add_L2 */
    case 285:  /* insn_ld1s_add_L2 */
    case 284:  /* insn_ld1u_add_L2_32bit */
    case 283:  /* insn_ld1s_add_L2_32bit */
    case 270:  /* insn_ldnt4u_add */
    case 269:  /* insn_ldnt4s_add */
    case 268:  /* insn_ldnt4u_add_32bit */
    case 267:  /* insn_ldnt4s_add_32bit */
    case 266:  /* insn_ldnt2u_add */
    case 265:  /* insn_ldnt2s_add */
    case 264:  /* insn_ldnt2u_add_32bit */
    case 263:  /* insn_ldnt2s_add_32bit */
    case 262:  /* insn_ldnt1u_add */
    case 261:  /* insn_ldnt1s_add */
    case 260:  /* insn_ldnt1u_add_32bit */
    case 259:  /* insn_ldnt1s_add_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0, 0), 0);
      recog_data.dup_num[0] = 3;
      break;

    case 327:  /* insn_ld4u_miss */
    case 326:  /* insn_ld4s_miss */
    case 325:  /* insn_ld2u_miss */
    case 324:  /* insn_ld2s_miss */
    case 323:  /* insn_ld1u_miss */
    case 322:  /* insn_ld1s_miss */
    case 282:  /* insn_ld4u_L2 */
    case 281:  /* insn_ld4s_L2 */
    case 280:  /* insn_ld2u_L2 */
    case 279:  /* insn_ld2s_L2 */
    case 278:  /* insn_ld1u_L2 */
    case 277:  /* insn_ld1s_L2 */
    case 258:  /* insn_ldnt4u */
    case 257:  /* insn_ldnt4s */
    case 256:  /* insn_ldnt2u */
    case 255:  /* insn_ldnt2s */
    case 254:  /* insn_ldnt1u */
    case 253:  /* insn_ldnt1s */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0), 0));
      break;

    case 318:  /* insn_ld_add_miss */
    case 317:  /* insn_ld_add_miss_32bit */
    case 273:  /* insn_ld_add_L2 */
    case 272:  /* insn_ld_add_L2_32bit */
    case 252:  /* insn_ldnt_add */
    case 251:  /* insn_ldnt_add_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0);
      recog_data.dup_num[0] = 3;
      break;

    case 316:  /* insn_ld_miss */
    case 271:  /* insn_ld_L2 */
    case 250:  /* insn_ldnt */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      break;

    case 249:  /* insn_ld4u_add */
    case 248:  /* insn_ld4s_add */
    case 247:  /* insn_ld4u_add_32bit */
    case 246:  /* insn_ld4s_add_32bit */
    case 245:  /* insn_ld2u_add */
    case 244:  /* insn_ld2s_add */
    case 243:  /* insn_ld2u_add_32bit */
    case 242:  /* insn_ld2s_add_32bit */
    case 241:  /* insn_ld1u_add */
    case 240:  /* insn_ld1s_add */
    case 239:  /* insn_ld1u_add_32bit */
    case 238:  /* insn_ld1s_add_32bit */
    case 237:  /* insn_ldna_add */
    case 236:  /* insn_ldna_add_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 3;
      break;

    case 234:  /* insn_ld_add */
    case 233:  /* insn_ld_add_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 3;
      break;

    case 211:  /* insn_fetchaddgez */
    case 210:  /* insn_fetchaddgez4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 215:  /* insn_fetchor */
    case 214:  /* insn_fetchor4 */
    case 213:  /* insn_fetchand */
    case 212:  /* insn_fetchand4 */
    case 209:  /* insn_fetchadd */
    case 208:  /* insn_fetchadd4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 199:  /* insn_exch */
    case 198:  /* insn_exch4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 391:  /* insn_prefetch_l3_fault */
    case 390:  /* insn_prefetch_l2_fault */
    case 389:  /* insn_prefetch_l1_fault */
    case 232:  /* insn_inv */
    case 231:  /* insn_infol */
    case 230:  /* insn_info */
    case 228:  /* insn_icoh */
    case 217:  /* insn_flush */
    case 216:  /* insn_finv */
    case 197:  /* insn_dtlbpr */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 183:  /* insn_cmpexch */
    case 182:  /* insn_cmpexch4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 178:  /* prefetch */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 2));
      break;

    case 177:  /* *memory_barrier */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 176:  /* *blbc_normaldi */
    case 175:  /* *blbc_normalsi */
    case 174:  /* *blbs_normaldi */
    case 173:  /* *blbs_normalsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      break;

    case 172:  /* *bcc_reversedi */
    case 171:  /* *bcc_reversesi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 170:  /* *bcc_normaldi */
    case 169:  /* *bcc_normalsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 166:  /* sp_restore */
    case 165:  /* sp_restore_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 164:  /* sp_adjust_32bit */
    case 163:  /* sp_adjust */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 161:  /* tablejump_aux */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 516:  /* tilegx_network_barrier */
    case 386:  /* insn_nap */
    case 229:  /* insn_ill */
    case 227:  /* insn_drain */
    case 219:  /* insn_fnop */
    case 218:  /* insn_flushwb */
    case 168:  /* trap */
    case 167:  /* nop */
    case 162:  /* blockage */
    case 160:  /* _return */
      break;

    case 159:  /* indirect_jump */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 158:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 157:  /* *sibcall_value */
    case 156:  /* *sibcall_value */
    case 153:  /* *call_value_insn */
    case 152:  /* *call_value_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 155:  /* *sibcall_insn */
    case 154:  /* *sibcall_insn */
    case 151:  /* *call_insn */
    case 150:  /* *call_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 149:  /* umaddsidi4 */
    case 148:  /* maddsidi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 143:  /* *rotldi_truncdisi */
    case 142:  /* *lshrdi_truncdisi */
    case 139:  /* *ashrdi3_truncdisi */
    case 136:  /* *ashldi_truncdisi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 488:  /* vec_pack_ssat_v2si */
    case 486:  /* vec_pack_usat_v4hi */
    case 485:  /* vec_pack_trunc_v4hi */
    case 388:  /* insn_nor_di */
    case 387:  /* insn_nor_si */
    case 147:  /* usmulsidi3 */
    case 146:  /* umulsidi3 */
    case 145:  /* mulsidi3 */
    case 141:  /* *lshrsi_truncdisi2 */
    case 138:  /* *ashlsi_truncdisi2 */
    case 135:  /* *addsi_truncdisi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 119:  /* movcc_insn_didi */
    case 118:  /* movcc_insn_disi */
    case 117:  /* movcc_insn_sidi */
    case 116:  /* movcc_insn_sisi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 480:  /* insn_mnz_v4hi */
    case 478:  /* insn_mnz_v8qi */
    case 398:  /* insn_shl3addx */
    case 397:  /* insn_shl3add */
    case 396:  /* insn_shl2addx */
    case 395:  /* insn_shl2add */
    case 394:  /* insn_shl1addx */
    case 393:  /* insn_shl1add */
    case 140:  /* *lshrsi_truncdisi */
    case 137:  /* *ashlsi_truncdisi */
    case 134:  /* *addsi_truncdisi */
    case 60:  /* insn_shl16insli */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 235:  /* insn_ldna */
    case 133:  /* *zero_extendsidi_truncdisi */
    case 45:  /* *negsi2_sext */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 132:  /* truncdiqi2 */
    case 131:  /* truncdihi2 */
    case 130:  /* truncdisi2 */
    case 129:  /* extendsidi2 */
    case 128:  /* extendhidi2 */
    case 127:  /* extendhisi2 */
    case 126:  /* extendqidi2 */
    case 125:  /* extendqisi2 */
    case 124:  /* zero_extendsidi2 */
    case 123:  /* zero_extendhidi2 */
    case 122:  /* zero_extendhisi2 */
    case 121:  /* zero_extendqidi2 */
    case 120:  /* zero_extendqisi2 */
    case 115:  /* one_cmplv2si2 */
    case 114:  /* one_cmplv4hi2 */
    case 113:  /* one_cmplv8qi2 */
    case 112:  /* one_cmpldi2 */
    case 111:  /* one_cmplsi2 */
    case 110:  /* bswapdi2 */
    case 109:  /* popcountdi2 */
    case 108:  /* popcountsi2 */
    case 107:  /* ctzdi2 */
    case 106:  /* ctzsi2 */
    case 105:  /* clzdi2 */
    case 44:  /* negdi2 */
    case 43:  /* negsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 477:  /* vec_interleave_lowv2si_le */
    case 476:  /* vec_interleave_lowv2si_be */
    case 475:  /* vec_interleave_highv2si_le */
    case 474:  /* vec_interleave_highv2si_be */
    case 473:  /* vec_interleave_lowv4hi_le */
    case 472:  /* vec_interleave_lowv4hi_be */
    case 471:  /* vec_interleave_highv4hi_le */
    case 470:  /* vec_interleave_highv4hi_be */
    case 469:  /* vec_interleave_lowv8qi_le */
    case 468:  /* vec_interleave_lowv8qi_be */
    case 467:  /* vec_interleave_highv8qi_le */
    case 466:  /* vec_interleave_highv8qi_be */
    case 104:  /* *xorsi3_sext */
    case 98:  /* *iorsi3_sext */
    case 91:  /* *andsi3_sext */
    case 58:  /* *lshrsi3_sext */
    case 55:  /* *ashrsi3_sext */
    case 52:  /* *ashlsi3_sext */
    case 49:  /* *sssubsi3_sext */
    case 47:  /* *ssaddsi3_sext */
    case 42:  /* *subsi3_sext */
    case 39:  /* *addsi3_sext */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 465:  /* ssashlv2si3 */
    case 464:  /* lshrv2si3 */
    case 463:  /* ashrv2si3 */
    case 462:  /* ashlv2si3 */
    case 461:  /* addv2si3 */
    case 460:  /* subv2si3 */
    case 459:  /* ssaddv2si3 */
    case 458:  /* sssubv2si3 */
    case 457:  /* ssashlv4hi3 */
    case 456:  /* mulv4hi3 */
    case 455:  /* sleuv4hi3 */
    case 454:  /* slev4hi3 */
    case 453:  /* snev4hi3 */
    case 452:  /* subv4hi3 */
    case 451:  /* ssaddv4hi3 */
    case 450:  /* sssubv4hi3 */
    case 449:  /* mulv8qi3 */
    case 448:  /* sleuv8qi3 */
    case 447:  /* slev8qi3 */
    case 446:  /* snev8qi3 */
    case 445:  /* subv8qi3 */
    case 444:  /* usaddv8qi3 */
    case 443:  /* ussubv8qi3 */
    case 442:  /* lshrv4hi3 */
    case 441:  /* ashrv4hi3 */
    case 440:  /* ashlv4hi3 */
    case 439:  /* sltuv4hi3 */
    case 438:  /* sltv4hi3 */
    case 437:  /* seqv4hi3 */
    case 436:  /* sminv4hi3 */
    case 435:  /* smaxv4hi3 */
    case 434:  /* addv4hi3 */
    case 433:  /* lshrv8qi3 */
    case 432:  /* ashrv8qi3 */
    case 431:  /* ashlv8qi3 */
    case 430:  /* sltuv8qi3 */
    case 429:  /* sltv8qi3 */
    case 428:  /* seqv8qi3 */
    case 427:  /* uminv8qi3 */
    case 426:  /* umaxv8qi3 */
    case 425:  /* addv8qi3 */
    case 144:  /* mulsi3 */
    case 103:  /* xorv2si3 */
    case 102:  /* xorv4hi3 */
    case 101:  /* xorv8qi3 */
    case 100:  /* xordi3 */
    case 99:  /* xorsi3 */
    case 97:  /* iorv2si3 */
    case 96:  /* iorv4hi3 */
    case 95:  /* iorv8qi3 */
    case 94:  /* iordi3 */
    case 93:  /* iorsi3 */
    case 92:  /* anddi3 */
    case 90:  /* andv2si3 */
    case 89:  /* andv4hi3 */
    case 88:  /* andv8qi3 */
    case 87:  /* andsi3 */
    case 86:  /* insn_cmpleu_didi */
    case 85:  /* insn_cmpleu_sidi */
    case 84:  /* insn_cmpleu_disi */
    case 83:  /* insn_cmpleu_sisi */
    case 82:  /* insn_cmples_didi */
    case 81:  /* insn_cmples_sidi */
    case 80:  /* insn_cmples_disi */
    case 79:  /* insn_cmples_sisi */
    case 78:  /* insn_cmpltu_didi */
    case 77:  /* insn_cmpltu_sidi */
    case 76:  /* insn_cmpltu_disi */
    case 75:  /* insn_cmpltu_sisi */
    case 74:  /* insn_cmplts_didi */
    case 73:  /* insn_cmplts_sidi */
    case 72:  /* insn_cmplts_disi */
    case 71:  /* insn_cmplts_sisi */
    case 70:  /* insn_cmpeq_didi */
    case 69:  /* insn_cmpeq_sidi */
    case 68:  /* insn_cmpeq_disi */
    case 67:  /* insn_cmpeq_sisi */
    case 66:  /* insn_cmpne_didi */
    case 65:  /* insn_cmpne_sidi */
    case 64:  /* insn_cmpne_disi */
    case 63:  /* insn_cmpne_sisi */
    case 59:  /* rotldi3 */
    case 57:  /* lshrdi3 */
    case 56:  /* lshrsi3 */
    case 54:  /* ashrdi3 */
    case 53:  /* ashrsi3 */
    case 51:  /* ashldi3 */
    case 50:  /* ashlsi3 */
    case 48:  /* sssubsi3 */
    case 46:  /* ssaddsi3 */
    case 41:  /* subdi3 */
    case 40:  /* subsi3 */
    case 38:  /* adddi3 */
    case 37:  /* addsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 36:  /* *sign_extract */
    case 35:  /* *sign_extract */
    case 34:  /* *sign_extract_low32 */
    case 33:  /* *zero_extractdi */
    case 32:  /* *zero_extractsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 510:  /* insn_v2sadau */
    case 509:  /* insn_v2sadas */
    case 507:  /* insn_v2dotpa */
    case 501:  /* insn_v1sadau */
    case 500:  /* insn_v1dotpusa */
    case 498:  /* insn_v1dotpua */
    case 496:  /* insn_v1dotpa */
    case 494:  /* insn_v1ddotpusa */
    case 492:  /* insn_v1ddotpua */
    case 399:  /* insn_shufflebytes */
    case 385:  /* insn_mulax */
    case 384:  /* insn_mula_lu_lu */
    case 383:  /* insn_mula_ls_lu */
    case 382:  /* insn_mula_ls_ls */
    case 381:  /* insn_mula_hu_lu */
    case 380:  /* insn_mula_hu_ls */
    case 379:  /* insn_mula_hu_hu */
    case 378:  /* insn_mula_hs_lu */
    case 377:  /* insn_mula_hs_ls */
    case 376:  /* insn_mula_hs_hu */
    case 375:  /* insn_mula_hs_hs */
    case 221:  /* insn_fsingle_addsub2 */
    case 204:  /* insn_fdouble_pack2 */
    case 201:  /* insn_fdouble_addsub */
    case 193:  /* insn_dblalign */
    case 186:  /* insn_cmulaf */
    case 185:  /* insn_cmula */
    case 180:  /* insn_bfextu */
    case 179:  /* insn_bfexts */
    case 29:  /* tls_add */
    case 28:  /* tls_add_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 513:  /* insn_v2sadu */
    case 511:  /* insn_v2sads */
    case 508:  /* insn_v2mulfsc */
    case 506:  /* insn_v2dotp */
    case 505:  /* insn_v2avgs */
    case 504:  /* insn_v2adiffs */
    case 502:  /* insn_v1sadu */
    case 499:  /* insn_v1dotpus */
    case 497:  /* insn_v1dotpu */
    case 495:  /* insn_v1dotp */
    case 493:  /* insn_v1ddotpus */
    case 491:  /* insn_v1ddotpu */
    case 490:  /* insn_v1avgu */
    case 489:  /* insn_v1adiffu */
    case 424:  /* insn_tblidxb3 */
    case 423:  /* insn_tblidxb2 */
    case 422:  /* insn_tblidxb1 */
    case 421:  /* insn_tblidxb0 */
    case 400:  /* insn_shufflebytes1 */
    case 374:  /* insn_mul_lu_lu */
    case 373:  /* insn_mul_ls_lu */
    case 372:  /* insn_mul_ls_ls */
    case 371:  /* insn_mul_hu_lu */
    case 370:  /* insn_mul_hu_ls */
    case 369:  /* insn_mul_hu_hu */
    case 368:  /* insn_mul_hs_lu */
    case 367:  /* insn_mul_hs_ls */
    case 366:  /* insn_mul_hs_hu */
    case 365:  /* insn_mul_hs_hs */
    case 226:  /* insn_fsingle_sub1 */
    case 225:  /* insn_fsingle_pack2 */
    case 223:  /* insn_fsingle_mul2 */
    case 222:  /* insn_fsingle_mul1 */
    case 220:  /* insn_fsingle_add1 */
    case 207:  /* insn_fdouble_unpack_min */
    case 206:  /* insn_fdouble_unpack_max */
    case 205:  /* insn_fdouble_sub_flags */
    case 203:  /* insn_fdouble_pack1 */
    case 202:  /* insn_fdouble_mul_flags */
    case 200:  /* insn_fdouble_add_flags */
    case 196:  /* insn_dblalign6 */
    case 195:  /* insn_dblalign4 */
    case 194:  /* insn_dblalign2 */
    case 192:  /* insn_crc32_8 */
    case 191:  /* insn_crc32_32 */
    case 190:  /* insn_cmulhr */
    case 189:  /* insn_cmulh */
    case 188:  /* insn_cmulfr */
    case 187:  /* insn_cmulf */
    case 184:  /* insn_cmul */
    case 62:  /* insn_addr_shl16insli */
    case 61:  /* insn_addr_shl16insli_32bit */
    case 31:  /* tls_ie_load */
    case 30:  /* tls_ie_load_32bit */
    case 27:  /* tls_gd_add */
    case 26:  /* tls_gd_add_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 25:  /* *tls_gd_call */
    case 24:  /* *tls_gd_call_32bit */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      break;

    case 364:  /* insn_mm */
    case 181:  /* insn_bfins */
    case 23:  /* mov_large_pcrel_step4 */
    case 22:  /* mov_pcrel_step3 */
    case 21:  /* mov_pcrel_step3_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (pat, 1), 0, 3));
      break;

    case 392:  /* insn_revbits */
    case 224:  /* insn_fsingle_pack1 */
    case 20:  /* insn_lnk_and_label */
    case 19:  /* insn_lnk_and_label_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 18:  /* *insv_mm */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (pat, 1), 2);
      recog_data.dup_num[1] = 2;
      break;

    case 17:  /* *insv_bfins */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 16:  /* *insv_tblidxb3 */
    case 15:  /* *insv_tblidxb2 */
    case 14:  /* *insv_tblidxb1 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 13:  /* *insv_tblidxb0 */
    case 12:  /* movstrictsi */
    case 11:  /* movstricthi */
    case 10:  /* movstrictqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 9:  /* *movv2si */
    case 8:  /* *movv4hi */
    case 7:  /* *movv8qi */
    case 6:  /* *movdf */
    case 5:  /* *movsf */
    case 4:  /* *movdi_insn */
    case 3:  /* *movsi_insn */
    case 2:  /* *movhi_insn */
    case 1:  /* *movqi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    }
}
