/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
internal_dfa_insn_code (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_tune_arc700 cached_tune_arc700 ATTRIBUTE_UNUSED;
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 439:  /* vld32_insn */
    case 438:  /* vld64_insn */
    case 437:  /* vld64w_insn */
    case 436:  /* vld32wl_insn */
    case 435:  /* vld32wh_insn */
    case 411:  /* vmovw_insn */
    case 409:  /* vd6tapf_insn */
    case 407:  /* vmvw_insn */
      return 66 /* 0x42 */;

    case 426:  /* vupsbw_insn */
    case 424:  /* vupbw_insn */
    case 422:  /* vexch4_insn */
    case 421:  /* vexch2_insn */
    case 420:  /* vexch1_insn */
    case 413:  /* vsr8_insn */
    case 405:  /* vsr8i_insn */
    case 403:  /* vasrrpwbi_insn */
    case 402:  /* vasrpwbi_insn */
    case 400:  /* vasrsrwi_insn */
    case 399:  /* vasrrwi_insn */
    case 396:  /* vbmulw_insn */
    case 395:  /* vbmulfw_insn */
    case 385:  /* vmrb_insn */
    case 384:  /* vmr7w_insn */
    case 382:  /* vmr6w_insn */
    case 380:  /* vmr5w_insn */
    case 378:  /* vmr4w_insn */
    case 376:  /* vmr3w_insn */
    case 374:  /* vmr2w_insn */
    case 372:  /* vmr1w_insn */
    case 359:  /* vsummw_insn */
    case 356:  /* vmulw_insn */
    case 355:  /* vmulfw_insn */
      return 64 /* 0x40 */;

    case 419:  /* vsignw_insn */
    case 418:  /* vaddsuw_insn */
    case 417:  /* vabsw_insn */
    case 414:  /* vasrw_insn */
    case 412:  /* vmovzw_insn */
    case 408:  /* vmvzw_insn */
    case 401:  /* vasrwi_insn */
    case 398:  /* vbsubw_insn */
    case 397:  /* vbrsubw_insn */
    case 393:  /* vbminw_insn */
    case 392:  /* vbmaxw_insn */
    case 391:  /* vbaddw_insn */
    case 370:  /* vnew_insn */
    case 369:  /* vltw_insn */
    case 368:  /* vlew_insn */
    case 367:  /* veqw_insn */
    case 365:  /* vxor_insn */
    case 364:  /* vor_insn */
    case 362:  /* vbic_insn */
    case 360:  /* vand_insn */
    case 358:  /* vsubw_insn */
    case 352:  /* vminw_insn */
    case 350:  /* vmaxw_insn */
    case 348:  /* vdifw_insn */
    case 346:  /* vavrb_insn */
    case 345:  /* vavb_insn */
    case 344:  /* vaddw_insn */
      return 63 /* 0x3f */;

    case 342:  /* movti_insn */
    case 341:  /* movv8hi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 1)
        {
	  return 62 /* 0x3e */;
        }
      else if (!((1ULL << which_alternative) & 0x3ULL))
        {
	  return 63 /* 0x3f */;
        }
      else
        {
	  return 65 /* 0x41 */;
        }

    case 442:  /* vinti_insn */
    case 441:  /* vst32_n_insn */
    case 440:  /* vst16_n_insn */
    case 434:  /* vendrec_insn */
    case 433:  /* vrecrun_insn */
    case 432:  /* vrun_insn */
    case 431:  /* vrec_insn */
    case 430:  /* vdowr_insn */
    case 429:  /* vdiwr_insn */
    case 428:  /* vdorun_insn */
    case 427:  /* vdirun_insn */
    case 340:  /* vst64_insn */
    case 339:  /* vst128_insn */
      return 62 /* 0x3e */;

    case 425:  /* vupsbaw_insn */
    case 423:  /* vupbaw_insn */
    case 416:  /* vabsaw_insn */
    case 415:  /* vsr8aw_insn */
    case 410:  /* vmovaw_insn */
    case 406:  /* vmvaw_insn */
    case 404:  /* vsr8awi_insn */
    case 394:  /* vbmulaw_insn */
    case 390:  /* vvc1ft_insn */
    case 389:  /* vvc1f_insn */
    case 388:  /* vh264fw_insn */
    case 387:  /* vh264ft_insn */
    case 386:  /* vh264f_insn */
    case 383:  /* vmr7aw_insn */
    case 381:  /* vmr6aw_insn */
    case 379:  /* vmr5aw_insn */
    case 377:  /* vmr4aw_insn */
    case 375:  /* vmr3aw_insn */
    case 373:  /* vmr2aw_insn */
    case 371:  /* vmr1aw_insn */
    case 366:  /* vxoraw_insn */
    case 363:  /* vbicaw_insn */
    case 361:  /* vandaw_insn */
    case 357:  /* vsubaw_insn */
    case 354:  /* vmulfaw_insn */
    case 353:  /* vmulaw_insn */
    case 351:  /* vminaw_insn */
    case 349:  /* vmaxaw_insn */
    case 347:  /* vdifaw_insn */
    case 343:  /* vaddaw_insn */
    case 338:  /* vld128_insn */
      return 65 /* 0x41 */;

    case 717:  /* *p divdf3 */
    case 316:  /* sqrtdf2 */
    case 315:  /* divdf3 */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 55 /* 0x37 */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 711:  /* *p *divsf3_fpu */
    case 308:  /* sqrtsf2_fpu */
    case 307:  /* *divsf3_fpu */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 54 /* 0x36 */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 710:  /* *p fnmadf4_fpu */
    case 709:  /* *p fmadf4_fpu */
    case 708:  /* *p fnmasf4_fpu */
    case 707:  /* *p fmasf4_fpu */
    case 306:  /* fnmadf4_fpu */
    case 305:  /* fmadf4_fpu */
    case 302:  /* fnmasf4_fpu */
    case 301:  /* fmasf4_fpu */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 53 /* 0x35 */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 737:  /* *p fix_truncdfsi2 */
    case 736:  /* *p fixuns_truncdfsi2 */
    case 735:  /* *p floatunsdisf2 */
    case 734:  /* *p floatdisf2 */
    case 733:  /* *p truncdfsf2 */
    case 732:  /* *p fix_truncdfdi2 */
    case 731:  /* *p fixuns_truncdfdi2 */
    case 730:  /* *p floatunsdidf2 */
    case 729:  /* *p floatdidf2 */
    case 728:  /* *p fix_truncsfsi2_fpu */
    case 727:  /* *p fixuns_truncsfsi2 */
    case 726:  /* *p floatunssisf2 */
    case 725:  /* *p floatsisf2_fpu */
    case 724:  /* *p fix_truncsfdi2 */
    case 723:  /* *p fixuns_truncsfdi2 */
    case 722:  /* *p floatunssidf2 */
    case 721:  /* *p floatsidf2 */
    case 720:  /* *p extendsfdf2 */
    case 719:  /* *p *cmpdf_fpu_trap */
    case 718:  /* *p *cmpdf_fpu */
    case 716:  /* *p *muldf3_fpu */
    case 715:  /* *p *subdf3_fpu */
    case 714:  /* *p *adddf3_fpu */
    case 713:  /* *p *cmpsf_fpu_trap */
    case 712:  /* *p *cmpsf_fpu */
    case 706:  /* *p *mulsf3_fpu */
    case 705:  /* *p *subsf3_fpu */
    case 704:  /* *p *addsf3_fpu */
    case 337:  /* fix_truncdfsi2 */
    case 336:  /* fixuns_truncdfsi2 */
    case 335:  /* floatunsdisf2 */
    case 334:  /* floatdisf2 */
    case 333:  /* truncdfsf2 */
    case 332:  /* fix_truncdfdi2 */
    case 331:  /* fixuns_truncdfdi2 */
    case 330:  /* floatunsdidf2 */
    case 329:  /* floatdidf2 */
    case 328:  /* fix_truncsfsi2_fpu */
    case 327:  /* fixuns_truncsfsi2 */
    case 326:  /* floatunssisf2 */
    case 325:  /* floatsisf2_fpu */
    case 324:  /* fix_truncsfdi2 */
    case 323:  /* fixuns_truncsfdi2 */
    case 322:  /* floatunssidf2 */
    case 321:  /* floatsidf2 */
    case 320:  /* extendsfdf2 */
    case 319:  /* *cmpdf_fpu_uneq */
    case 318:  /* *cmpdf_fpu_trap */
    case 317:  /* *cmpdf_fpu */
    case 314:  /* *muldf3_fpu */
    case 313:  /* *subdf3_fpu */
    case 312:  /* *adddf3_fpu */
    case 311:  /* *cmpsf_fpu_uneq */
    case 310:  /* *cmpsf_fpu_trap */
    case 309:  /* *cmpsf_fpu */
    case 300:  /* *mulsf3_fpu */
    case 299:  /* *subsf3_fpu */
    case 298:  /* *addsf3_fpu */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 52 /* 0x34 */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 287:  /* *dmulh_peep2_insn */
    case 284:  /* muldf3_insn */
      extract_constrain_insn_cached (insn);
      if (
#line 37 "../../gcc-10.2.1-20200826/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET))
        {
	  return 59 /* 0x3b */;
        }
      else if (
#line 47 "../../gcc-10.2.1-20200826/gcc/config/arc/fpx.md"
(TARGET_DPFP_FAST_SET))
        {
	  return 61 /* 0x3d */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 288:  /* *dsubh_peep2_insn */
    case 286:  /* *daddh_peep2_insn */
    case 285:  /* subdf3_insn */
    case 283:  /* adddf3_insn */
    case 275:  /* cmpdfpx_raw */
      extract_constrain_insn_cached (insn);
      if (
#line 37 "../../gcc-10.2.1-20200826/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET))
        {
	  return 60 /* 0x3c */;
        }
      else if (
#line 47 "../../gcc-10.2.1-20200826/gcc/config/arc/fpx.md"
(TARGET_DPFP_FAST_SET))
        {
	  return 61 /* 0x3d */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 274:  /* cmpsfpx_raw */
    case 273:  /* *mulsf3_fpx */
    case 272:  /* *subsf3_fpx */
    case 271:  /* *addsf3_fpx */
      extract_constrain_insn_cached (insn);
      if (
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/fpx.md"
(TARGET_SPFP_COMPACT_SET))
        {
	  return 57 /* 0x39 */;
        }
      else if (
#line 32 "../../gcc-10.2.1-20200826/gcc/config/arc/fpx.md"
(TARGET_SPFP_FAST_SET))
        {
	  return 58 /* 0x3a */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 157:  /* divaw */
      if (get_attr_tune_arc700 (insn) == TUNE_ARC700_TRUE)
        {
	  return 13 /* 0xd */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 191:  /* dbnz */
    case 189:  /* loop_end */
    case 188:  /* arc_lp */
    case 184:  /* p_return_i */
    case 183:  /* arc600_rtie */
    case 182:  /* simple_return */
    case 160:  /* rtie */
    case 148:  /* blockage */
      return 68 /* 0x44 */;

    case 673:  /* *p *cmpdf_ord */
    case 672:  /* *p *cmpdf_uneq */
    case 671:  /* *p *cmpdf_ge */
    case 670:  /* *p *cmpdf_gt */
    case 669:  /* *p *cmpdf_eq */
    case 668:  /* *p *cmpsf_ord */
    case 667:  /* *p *cmpsf_uneq */
    case 666:  /* *p *cmpsf_ge */
    case 665:  /* *p *cmpsf_gt */
    case 664:  /* *p *cmpsf_eq */
    case 662:  /* *p *sibcall_value_insn */
    case 661:  /* *p *sibcall_insn */
    case 659:  /* *p *call_value_i */
    case 658:  /* *p *call_i */
    case 269:  /* *pop_multi_fp_blink_ret */
    case 268:  /* *pop_multi_fp_ret */
    case 267:  /* *pop_multi_fp_blink */
    case 266:  /* *pop_multi_fp */
    case 265:  /* *push_multi_fp_blink */
    case 264:  /* *push_multi_fp */
    case 206:  /* *millicode_sibthunk_ld */
    case 205:  /* *millicode_thunk_ld */
    case 204:  /* *millicode_thunk_st */
    case 201:  /* *cmpdf_ord */
    case 200:  /* *cmpdf_uneq */
    case 199:  /* *cmpdf_ge */
    case 198:  /* *cmpdf_gt */
    case 197:  /* *cmpdf_eq */
    case 196:  /* *cmpsf_ord */
    case 195:  /* *cmpsf_uneq */
    case 194:  /* *cmpsf_ge */
    case 193:  /* *cmpsf_gt */
    case 192:  /* *cmpsf_eq */
    case 186:  /* *bbit */
    case 185:  /* cbranchsi4_scratch */
    case 181:  /* *sibcall_value_insn */
    case 180:  /* *sibcall_insn */
    case 144:  /* *call_value_i */
    case 143:  /* *call_i */
    case 142:  /* casesi_jump */
    case 140:  /* casesi_dispatch */
    case 139:  /* indirect_jump */
    case 138:  /* jump_i */
    case 137:  /* *rev_branch_insn */
    case 136:  /* *branch_insn */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 42 /* 0x2a */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case 634:  /* *p umac64_600 */
    case 630:  /* *p mac64_600 */
    case 629:  /* *p mul64_600 */
    case 623:  /* *p mac_600 */
    case 93:  /* umac64_600 */
    case 92:  /* umul64_600 */
    case 86:  /* mac64_600 */
    case 85:  /* mul64_600 */
    case 75:  /* mac_600 */
    case 74:  /* umul_600 */
      if ((
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600)))
        {
	  return 5;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      extract_constrain_insn_cached (insn);
      if (((
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_COMPARE))
        {
	  return 0;
        }
      else if (((
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD) && (GET_MODE (operands[0]) == DImode))
        {
	  return 1;
        }
      else if (((
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD) && (! (GET_MODE (operands[0]) == DImode)))
        {
	  return 2;
        }
      else if (((
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (
#line 48 "../../gcc-10.2.1-20200826/gcc/config/arc/arc600.md"
(arc_multcost < COSTS_N_INSNS (7))) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 3;
        }
      else if (((
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (
#line 54 "../../gcc-10.2.1-20200826/gcc/config/arc/arc600.md"
(arc_multcost >= COSTS_N_INSNS (7))) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 4;
        }
      else if (((
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_MULMAC_600))
        {
	  return 5;
        }
      else if (((cached_tune_arc700 = get_attr_tune_arc700 (insn)) == TUNE_ARC700_TRUE) && (((cached_type = get_attr_type (insn)) == TYPE_UNARY) || (cached_type == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_BINARY)) && (GET_MODE (operands[0]) == DImode))
        {
	  return 6;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_LR))
        {
	  return 7;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_SR))
        {
	  return 8;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && (((cached_type = get_attr_type (insn)) == TYPE_UNARY) || (cached_type == TYPE_MOVE) || (cached_type == TYPE_BINARY)))
        {
	  return 9;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_CMOVE))
        {
	  return 10 /* 0xa */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH))
        {
	  return 11 /* 0xb */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_TWO_CYCLE_CORE))
        {
	  return 12 /* 0xc */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_DIVAW))
        {
	  return 13 /* 0xd */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_SHIFT))
        {
	  return 14 /* 0xe */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_COMPARE))
        {
	  return 15 /* 0xf */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_COMPARE))
        {
	  return 16 /* 0x10 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_MULTI) && (GET_MODE (operands[0]) == DImode))
        {
	  return 17 /* 0x11 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_UMULTI) && (GET_MODE (operands[0]) == DImode))
        {
	  return 18 /* 0x12 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_UMULTI))
        {
	  return 19 /* 0x13 */;
        }
      else if ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC)))) && ((cached_type = get_attr_type (insn)) == TYPE_MULTI))
        {
	  return 21 /* 0x15 */;
        }
      else if ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD)))) && ((cached_type = get_attr_type (insn)) == TYPE_MULTI))
        {
	  return 22 /* 0x16 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 23 /* 0x17 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 24 /* 0x18 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(TARGET_EM)) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 25 /* 0x19 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(TARGET_EM)) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 26 /* 0x1a */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 39 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(arc_mpy_option > 0)) && (
#line 40 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(arc_mpy_option <= 2)) && ((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM))
        {
	  return 27 /* 0x1b */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 46 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(arc_mpy_option > 2)) && (
#line 47 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(arc_mpy_option <= 5)) && ((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM))
        {
	  return 28 /* 0x1c */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 53 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(arc_mpy_option == 6)) && ((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM))
        {
	  return 29 /* 0x1d */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 59 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(arc_mpy_option == 2)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 30 /* 0x1e */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 65 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(arc_mpy_option == 3)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 31 /* 0x1f */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 71 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(arc_mpy_option == 4)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 32 /* 0x20 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 78 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(arc_mpy_option == 5)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 33 /* 0x21 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 53 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(arc_mpy_option == 6)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 34 /* 0x22 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 91 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(TARGET_DIVREM)) && ((cached_type = get_attr_type (insn)) == TYPE_DIV_REM))
        {
	  return 35 /* 0x23 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD))) && (! (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 36 /* 0x24 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD))) && (! (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 37 /* 0x25 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD))) && (! (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH) || (cached_type == TYPE_TWO_CYCLE_CORE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_LR) || (cached_type == TYPE_SR)))
        {
	  return 38 /* 0x26 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD))) && (! (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_UNARY) || (cached_type == TYPE_BINARY) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_MISC)))
        {
	  return 39 /* 0x27 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (
#line 91 "../../gcc-10.2.1-20200826/gcc/config/arc/arcEM.md"
(TARGET_DIVREM)) && (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD))) && (! (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && ((cached_type = get_attr_type (insn)) == TYPE_DIV_REM))
        {
	  return 40 /* 0x28 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD))) && (! (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM) || (cached_type == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 41 /* 0x29 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_CALL) || (cached_type == TYPE_CALL_NO_DELAY_SLOT) || (cached_type == TYPE_UNCOND_BRANCH) || (cached_type == TYPE_JUMP) || (cached_type == TYPE_BRANCH) || (cached_type == TYPE_BRCC) || (cached_type == TYPE_BRCC_NO_DELAY_SLOT) || (cached_type == TYPE_SFUNC)))
        {
	  return 42 /* 0x2a */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 43 /* 0x2b */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 44 /* 0x2c */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH) || (cached_type == TYPE_TWO_CYCLE_CORE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_LR) || (cached_type == TYPE_SR)))
        {
	  return 45 /* 0x2d */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH) || (cached_type == TYPE_TWO_CYCLE_CORE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_LR) || (cached_type == TYPE_SR)))
        {
	  return 46 /* 0x2e */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_UNARY) || (cached_type == TYPE_BINARY) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_MISC)))
        {
	  return 47 /* 0x2f */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_UNARY) || (cached_type == TYPE_BINARY) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_MISC)))
        {
	  return 48 /* 0x30 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_DIV_REM))
        {
	  return 49 /* 0x31 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)) || (
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)))) && (((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM) || (cached_type == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 50 /* 0x32 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && (! (
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)))) && (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))) && (((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM) || (cached_type == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 51 /* 0x33 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU))
        {
	  return 52 /* 0x34 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_FUSE))
        {
	  return 53 /* 0x35 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_SDIV))
        {
	  return 54 /* 0x36 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_DDIV))
        {
	  return 55 /* 0x37 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X)))) || (((! (
#line 649 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC600))) && (! (
#line 651 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 653 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_STD))) && (! (
#line 655 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARC700_4_2_XMAC))) && (! (
#line 657 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_CORE_3))) && (! (
#line 659 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4X))) && ((
#line 661 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-10.2.1-20200826/gcc/config/arc/arc.md"
(arc_tune == TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_CVT))
        {
	  return 56 /* 0x38 */;
        }
      else if ((
#line 27 "../../gcc-10.2.1-20200826/gcc/config/arc/fpx.md"
(TARGET_SPFP_COMPACT_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_SPFP))
        {
	  return 57 /* 0x39 */;
        }
      else if ((
#line 32 "../../gcc-10.2.1-20200826/gcc/config/arc/fpx.md"
(TARGET_SPFP_FAST_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_SPFP))
        {
	  return 58 /* 0x3a */;
        }
      else if ((
#line 37 "../../gcc-10.2.1-20200826/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_DPFP_MULT))
        {
	  return 59 /* 0x3b */;
        }
      else if ((
#line 37 "../../gcc-10.2.1-20200826/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_DPFP_ADDSUB))
        {
	  return 60 /* 0x3c */;
        }
      else if ((
#line 47 "../../gcc-10.2.1-20200826/gcc/config/arc/fpx.md"
(TARGET_DPFP_FAST_SET)) && (((cached_type = get_attr_type (insn)) == TYPE_DPFP_MULT) || (cached_type == TYPE_DPFP_ADDSUB)))
        {
	  return 61 /* 0x3d */;
        }
      else if (((cached_type = get_attr_type (insn)) == TYPE_SIMD_DMA) || (cached_type == TYPE_SIMD_VSTORE) || (cached_type == TYPE_SIMD_VCONTROL))
        {
	  return 62 /* 0x3e */;
        }
      else if ((cached_type == TYPE_SIMD_VCOMPARE) || (cached_type == TYPE_SIMD_VLOGIC) || (cached_type == TYPE_SIMD_VMOVE_ELSE_ZERO) || (cached_type == TYPE_SIMD_VARITH_1CYCLE))
        {
	  return 63 /* 0x3f */;
        }
      else if ((cached_type == TYPE_SIMD_VALIGN) || (cached_type == TYPE_SIMD_VPERMUTE) || (cached_type == TYPE_SIMD_VPACK) || (cached_type == TYPE_SIMD_VARITH_2CYCLE))
        {
	  return 64 /* 0x40 */;
        }
      else if ((cached_type == TYPE_SIMD_VALIGN_WITH_ACC) || (cached_type == TYPE_SIMD_VPACK_WITH_ACC) || (cached_type == TYPE_SIMD_VLOGIC_WITH_ACC) || (cached_type == TYPE_SIMD_VLOAD128) || (cached_type == TYPE_SIMD_VMOVE_WITH_ACC) || (cached_type == TYPE_SIMD_VSPECIAL_3CYCLE) || (cached_type == TYPE_SIMD_VARITH_WITH_ACC))
        {
	  return 65 /* 0x41 */;
        }
      else if ((cached_type == TYPE_SIMD_VLOAD) || (cached_type == TYPE_SIMD_VMOVE) || (cached_type == TYPE_SIMD_VSPECIAL_4CYCLE))
        {
	  return 66 /* 0x42 */;
        }
      else
        {
	  return 68 /* 0x44 */;
        }

    }
}

