/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
bypass_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
num_delay_slots (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
get_attr_enabled (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_isa cached_isa ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 51:  /* ashlsi3 */
      extract_constrain_insn_cached (insn);
      if ((which_alternative != 7) || (
#line 64 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33)))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 50:  /* extendhisi2 */
    case 49:  /* extendqisi2 */
    case 20:  /* umulsidi3_internal */
    case 19:  /* mulsidi3_internal */
    case 16:  /* subdi3_internal */
    case 14:  /* *subsi3_flags */
      extract_constrain_insn_cached (insn);
      if ((which_alternative != 1) || (
#line 64 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33)))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 53:  /* ashrsi3 */
    case 52:  /* lshrsi3 */
    case 13:  /* subsi3 */
      extract_constrain_insn_cached (insn);
      if ((which_alternative != 3) || (
#line 64 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33)))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 48:  /* zero_extendhisi2 */
    case 47:  /* zero_extendqisi2 */
    case 30:  /* *xorsi3_flags */
    case 29:  /* xorsi3 */
    case 28:  /* *iorsi3_flags */
    case 27:  /* iorsi3 */
    case 26:  /* *andsi3_flags */
    case 25:  /* andsi3 */
    case 11:  /* adddi3_internal */
      extract_constrain_insn_cached (insn);
      if ((which_alternative != 2) || (
#line 64 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33)))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 21:  /* *mulsi3 */
    case 15:  /* subc_internal */
    case 10:  /* addc_internal */
      extract_constrain_insn_cached (insn);
      if ((which_alternative == 0) || ((which_alternative != 0) && (
#line 64 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33))))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 3:  /* *movsi_internal */
      extract_constrain_insn_cached (insn);
      if ((which_alternative != 8) || ((which_alternative == 8) && (
#line 64 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33))))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      extract_constrain_insn_cached (insn);
      if ((cached_isa = get_attr_isa (insn)) == ISA_BASE)
        {
	  return 1;
        }
      else if ((cached_isa == ISA_AM33) && (
#line 64 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33)))
        {
	  return 1;
        }
      else if ((cached_isa == ISA_AM33_2) && (
#line 68 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2)))
        {
	  return 1;
        }
      else if ((cached_isa == ISA_AM34) && (
#line 72 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM34)))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    default:
      return 1;

    }
}

enum attr_isa
get_attr_isa (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 51:  /* ashlsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7fULL))
        {
	  return ISA_BASE;
        }
      else
        {
	  return ISA_AM33;
        }

    case 53:  /* ashrsi3 */
    case 52:  /* lshrsi3 */
    case 13:  /* subsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return ISA_BASE;
        }
      else
        {
	  return ISA_AM33;
        }

    case 48:  /* zero_extendhisi2 */
    case 47:  /* zero_extendqisi2 */
    case 30:  /* *xorsi3_flags */
    case 29:  /* xorsi3 */
    case 28:  /* *iorsi3_flags */
    case 27:  /* iorsi3 */
    case 26:  /* *andsi3_flags */
    case 25:  /* andsi3 */
    case 11:  /* adddi3_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return ISA_BASE;
        }
      else
        {
	  return ISA_AM33;
        }

    case 3:  /* *movsi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0xffULL))
        {
	  return ISA_BASE;
        }
      else if (which_alternative == 8)
        {
	  return ISA_AM33;
        }
      else
        {
	  return ISA_BASE;
        }

    case 21:  /* *mulsi3 */
    case 15:  /* subc_internal */
    case 10:  /* addc_internal */
    case 14:  /* *subsi3_flags */
    case 16:  /* subdi3_internal */
    case 19:  /* mulsidi3_internal */
    case 20:  /* umulsidi3_internal */
    case 49:  /* extendqisi2 */
    case 50:  /* extendhisi2 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return ISA_BASE;
        }
      else
        {
	  return ISA_AM33;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return ISA_BASE;

    }
}

enum attr_liw_op
get_attr_liw_op (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 51:  /* ashlsi3 */
      return LIW_OP_ASL;

    case 52:  /* lshrsi3 */
      return LIW_OP_LSR;

    case 53:  /* ashrsi3 */
      return LIW_OP_ASR;

    case 29:  /* xorsi3 */
      return LIW_OP_XOR;

    case 27:  /* iorsi3 */
      return LIW_OP_OR;

    case 25:  /* andsi3 */
      return LIW_OP_AND;

    case 3:  /* *movsi_internal */
      return LIW_OP_MOV;

    case 13:  /* subsi3 */
      return LIW_OP_SUB;

    case 34:  /* cmpsi */
      return LIW_OP_CMP;

    case 8:  /* addsi3 */
      return LIW_OP_ADD;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return LIW_OP_NONE;

    }
}

enum attr_liw
get_attr_liw (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 53:  /* ashrsi3 */
    case 52:  /* lshrsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return LIW_OP2;
        }
      else
        {
	  return LIW_BOTH;
        }

    case 51:  /* ashlsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3fULL))
        {
	  return LIW_OP2;
        }
      else
        {
	  return LIW_BOTH;
        }

    case 34:  /* cmpsi */
    case 13:  /* subsi3 */
    case 8:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return LIW_EITHER;
        }
      else
        {
	  return LIW_BOTH;
        }

    case 3:  /* *movsi_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return LIW_BOTH;
        }
      else if (which_alternative == 1)
        {
	  return LIW_EITHER;
        }
      else if (which_alternative == 2)
        {
	  return LIW_BOTH;
        }
      else if (which_alternative == 3)
        {
	  return LIW_EITHER;
        }
      else
        {
	  return LIW_BOTH;
        }

    case 25:  /* andsi3 */
    case 27:  /* iorsi3 */
    case 29:  /* xorsi3 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return LIW_BOTH;
        }
      else if (which_alternative == 1)
        {
	  return LIW_OP1;
        }
      else
        {
	  return LIW_BOTH;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return LIW_BOTH;

    }
}

int
get_attr_timings (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 51:  /* ashlsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return 11 /* 0xb */;
        }
      else if (((1ULL << which_alternative) & 0xcULL))
        {
	  return 22 /* 0x16 */;
        }
      else
        {
	  return 11 /* 0xb */;
        }

    case 30:  /* *xorsi3_flags */
    case 29:  /* xorsi3 */
    case 28:  /* *iorsi3_flags */
    case 27:  /* iorsi3 */
    case 26:  /* *andsi3_flags */
    case 25:  /* andsi3 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 22 /* 0x16 */;
        }
      else
        {
	  return 11 /* 0xb */;
        }

    case 13:  /* subsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return 11 /* 0xb */;
        }
      else
        {
	  return 22 /* 0x16 */;
        }

    case 8:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0xfULL))
        {
	  return 11 /* 0xb */;
        }
      else
        {
	  return 22 /* 0x16 */;
        }

    case 1:  /* *movqi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return 11 /* 0xb */;
        }
      else if (which_alternative == 3)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 13 /* 0xd */;
	    }
	  else
	    {
	      return 24 /* 0x18 */;
	    }
        }
      else if (which_alternative == 4)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 11 /* 0xb */;
	    }
	  else
	    {
	      return 22 /* 0x16 */;
	    }
        }
      else
        {
	  return 11 /* 0xb */;
        }

    case 2:  /* *movhi_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 11 /* 0xb */;
        }
      else if (which_alternative == 1)
        {
	  return 11 /* 0xb */;
        }
      else if (which_alternative == 2)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 11 /* 0xb */;
	    }
	  else
	    {
	      return 22 /* 0x16 */;
	    }
        }
      else if (which_alternative == 3)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 13 /* 0xd */;
	    }
	  else
	    {
	      return 24 /* 0x18 */;
	    }
        }
      else if (which_alternative == 4)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 11 /* 0xb */;
	    }
	  else
	    {
	      return 22 /* 0x16 */;
	    }
        }
      else if (which_alternative == 5)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 11 /* 0xb */;
	    }
	  else
	    {
	      return 22 /* 0x16 */;
	    }
        }
      else
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 11 /* 0xb */;
	    }
	  else
	    {
	      return 22 /* 0x16 */;
	    }
        }

    case 3:  /* *movsi_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 11 /* 0xb */;
        }
      else if (which_alternative == 1)
        {
	  return 22 /* 0x16 */;
        }
      else if (which_alternative == 2)
        {
	  return 22 /* 0x16 */;
        }
      else if (which_alternative == 3)
        {
	  return 11 /* 0xb */;
        }
      else if (which_alternative == 4)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 11 /* 0xb */;
	    }
	  else
	    {
	      return 22 /* 0x16 */;
	    }
        }
      else if (which_alternative == 5)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 13 /* 0xd */;
	    }
	  else
	    {
	      return 24 /* 0x18 */;
	    }
        }
      else if (which_alternative == 6)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 11 /* 0xb */;
	    }
	  else
	    {
	      return 22 /* 0x16 */;
	    }
        }
      else if (which_alternative == 7)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 13 /* 0xd */;
	    }
	  else
	    {
	      return 24 /* 0x18 */;
	    }
        }
      else if (which_alternative == 8)
        {
	  return 11 /* 0xb */;
        }
      else if (which_alternative == 9)
        {
	  return 11 /* 0xb */;
        }
      else
        {
	  return 11 /* 0xb */;
        }

    case 4:  /* *movsf_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 11 /* 0xb */;
        }
      else if (which_alternative == 1)
        {
	  return 22 /* 0x16 */;
        }
      else if (which_alternative == 2)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 47 /* 0x2f */;
	    }
	  else
	    {
	      return 25 /* 0x19 */;
	    }
        }
      else if (which_alternative == 3)
        {
	  return 11 /* 0xb */;
        }
      else if (which_alternative == 4)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 13 /* 0xd */;
	    }
	  else
	    {
	      return 14 /* 0xe */;
	    }
        }
      else if (which_alternative == 5)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 13 /* 0xd */;
	    }
	  else
	    {
	      return 12 /* 0xc */;
	    }
        }
      else if (which_alternative == 6)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 13 /* 0xd */;
	    }
	  else
	    {
	      return 14 /* 0xe */;
	    }
        }
      else if (which_alternative == 7)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 13 /* 0xd */;
	    }
	  else
	    {
	      return 24 /* 0x18 */;
	    }
        }
      else if (which_alternative == 8)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 13 /* 0xd */;
	    }
	  else
	    {
	      return 24 /* 0x18 */;
	    }
        }
      else if (which_alternative == 9)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 13 /* 0xd */;
	    }
	  else
	    {
	      return 24 /* 0x18 */;
	    }
        }
      else if (which_alternative == 10)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 13 /* 0xd */;
	    }
	  else
	    {
	      return 24 /* 0x18 */;
	    }
        }
      else if (which_alternative == 11)
        {
	  return 22 /* 0x16 */;
        }
      else
        {
	  return 22 /* 0x16 */;
        }

    case 9:  /* *addsi3_flags */
    case 14:  /* *subsi3_flags */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 11 /* 0xb */;
        }
      else
        {
	  return 22 /* 0x16 */;
        }

    case 19:  /* mulsidi3_internal */
    case 20:  /* umulsidi3_internal */
    case 21:  /* *mulsi3 */
      if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
        {
	  return 24 /* 0x18 */;
        }
      else
        {
	  return 23 /* 0x17 */;
        }

    case 22:  /* *udivmodsi4 */
    case 24:  /* *divmodsi4 */
      if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
        {
	  return 3839 /* 0xeff */;
        }
      else
        {
	  return 4243 /* 0x1093 */;
        }

    case 34:  /* cmpsi */
      if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
        {
	  return 11 /* 0xb */;
        }
      else
        {
	  return 22 /* 0x16 */;
        }

    case 39:  /* *am33_cmpsf */
      if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
        {
	  return 17 /* 0x11 */;
        }
      else
        {
	  return 25 /* 0x19 */;
        }

    case 40:  /* *float_conditional_branch */
      if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
        {
	  return 44 /* 0x2c */;
        }
      else
        {
	  return 33 /* 0x21 */;
        }

    case 41:  /* jump */
      if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
        {
	  return 11 /* 0xb */;
        }
      else
        {
	  return 44 /* 0x2c */;
        }

    case 42:  /* indirect_jump */
    case 43:  /* tablejump */
      if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
        {
	  return 11 /* 0xb */;
        }
      else
        {
	  return 33 /* 0x21 */;
        }

    case 44:  /* *call_internal */
    case 45:  /* call_value_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 33 /* 0x21 */;
	    }
	  else
	    {
	      return 44 /* 0x2c */;
	    }
        }
      else
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 55 /* 0x37 */;
	    }
	  else
	    {
	      return 33 /* 0x21 */;
	    }
        }

    case 47:  /* zero_extendqisi2 */
    case 48:  /* zero_extendhisi2 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 11 /* 0xb */;
        }
      else if (which_alternative == 1)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 13 /* 0xd */;
	    }
	  else
	    {
	      return 24 /* 0x18 */;
	    }
        }
      else
        {
	  return 11 /* 0xb */;
        }

    case 55:  /* abssf2 */
    case 56:  /* negsf2 */
      if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
        {
	  return 17 /* 0x11 */;
        }
      else
        {
	  return 14 /* 0xe */;
        }

    case 57:  /* rsqrtsf2 */
      if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
        {
	  return 4753 /* 0x1291 */;
        }
      else
        {
	  return 2327 /* 0x917 */;
        }

    case 58:  /* addsf3 */
    case 59:  /* subsf3 */
    case 60:  /* mulsf3 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 17 /* 0x11 */;
	    }
	  else
	    {
	      return 14 /* 0xe */;
	    }
        }
      else
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 17 /* 0x11 */;
	    }
	  else
	    {
	      return 25 /* 0x19 */;
	    }
        }

    case 61:  /* divsf3 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 2531 /* 0x9e3 */;
	    }
	  else
	    {
	      return 1216 /* 0x4c0 */;
	    }
        }
      else
        {
	  if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
	    {
	      return 2531 /* 0x9e3 */;
	    }
	  else
	    {
	      return 1317 /* 0x525 */;
	    }
        }

    case 62:  /* fmasf4 */
    case 63:  /* fmssf4 */
    case 64:  /* fnmasf4 */
    case 65:  /* fnmssf4 */
      if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
        {
	  return 17 /* 0x11 */;
        }
      else
        {
	  return 24 /* 0x18 */;
        }

    case 68:  /* store_movm */
      if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
        {
	  return 99 /* 0x63 */;
        }
      else
        {
	  return 88 /* 0x58 */;
        }

    case 69:  /* am33_load_pic */
      return 33 /* 0x21 */;

    case 70:  /* mn10300_load_pic0 */
      return 88 /* 0x58 */;

    case 71:  /* mn10300_load_pic1 */
      return 66 /* 0x42 */;

    case 72:  /* liw */
    case 73:  /* cmp_liw */
    case 74:  /* liw_cmp */
      if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
        {
	  return 13 /* 0xd */;
        }
      else
        {
	  return 12 /* 0xc */;
        }

    case 77:  /* FLcc */
      if (((
#line 53 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((enum attr_cpu) mn10300_tune_cpu)) == (
(CPU_AM34))))
        {
	  return 44 /* 0x2c */;
        }
      else
        {
	  return 11 /* 0xb */;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 11 /* 0xb */;

    }
}

int
eligible_for_delay (rtx_insn *delay_insn ATTRIBUTE_UNUSED, int slot, 
		   rtx_insn *candidate_insn, int flags ATTRIBUTE_UNUSED)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;

  if (num_delay_slots (delay_insn) == 0)
    return 0;
  gcc_assert (slot < 0);

  if (!INSN_P (candidate_insn))
    return 0;

  insn = candidate_insn;
  switch (slot)
    {
    default:
      gcc_unreachable ();
    }
}

int
eligible_for_annul_true (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
eligible_for_annul_false (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
const_num_delay_slots (rtx_insn *insn)
{
  switch (recog_memoized (insn))
    {
    default:
      return 1;
    }
}

EXPORTED_CONST int length_unit_log = 0;
