/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-10.2.1-20200826/gcc/config/tilegx/tilegx.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 26 "../../gcc-10.2.1-20200826/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 32 "../../gcc-10.2.1-20200826/gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 41 "../../gcc-10.2.1-20200826/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 43 "../../gcc-10.2.1-20200826/gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 50 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 51 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 57 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 58 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 62 "../../gcc-10.2.1-20200826/gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 66 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONSTANT_P (op))) && (
#line 67 "../../gcc-10.2.1-20200826/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 71 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONSTANT_P (op))) && ((
#line 72 "../../gcc-10.2.1-20200826/gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 73 "../../gcc-10.2.1-20200826/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 77 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 78 "../../gcc-10.2.1-20200826/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 82 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 83 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 89 "../../gcc-10.2.1-20200826/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 90 "../../gcc-10.2.1-20200826/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 95 "../../gcc-10.2.1-20200826/gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_I (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 36 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(ival >= -128 && ival <= 127));
}
static inline bool
satisfies_constraint_J (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 41 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(ival >= -32768 && ival <= 32767));
}
static inline bool
satisfies_constraint_K (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 46 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
((ival >= 0 && ival <= 65535)));
}
static inline bool
satisfies_constraint_L (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 51 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(ival >= -129 && ival <= 126));
}
static inline bool
satisfies_constraint_M (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 56 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(tilegx_bitfield_operand_p (ival, NULL, NULL)));
}
static inline bool
satisfies_constraint_N (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 61 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
((ival == (ival & 0xFF) * 0x0101010101010101LL)));
}
static inline bool
satisfies_constraint_O (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 66 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(ival == 0));
}
static inline bool
satisfies_constraint_P (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 71 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
((ival
                     == ((trunc_int_for_mode (ival, QImode) & 0xFFFF)
                         * 0x0001000100010001LL))));
}
static inline bool
satisfies_constraint_Q (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 78 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(ival >= -129 && ival <= 126 && ival != -1));
}
static inline bool
satisfies_constraint_S (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 83 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(ival != 0 && (ival & (ival + 1)) == 0));
}
static inline bool
satisfies_constraint_T (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (const_last_symbolic_operand (op, mode)) || (const_symbolic_operand (op, mode));
}
static inline bool
satisfies_constraint_U (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 93 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(GET_RTX_CLASS (GET_CODE (XEXP (op, 0))) != RTX_AUTOINC));
}
static inline bool
satisfies_constraint_W (rtx op)
{
  return (GET_CODE (op) == CONST_VECTOR) && ((
#line 98 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(CONST_VECTOR_NUNITS (op) == 8)) && (
#line 99 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(const_vec_duplicate_p (op))));
}
static inline bool
satisfies_constraint_Y (rtx op)
{
  return (GET_CODE (op) == CONST_VECTOR) && ((
#line 104 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(CONST_VECTOR_NUNITS (op) == 4)) && (
#line 105 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(const_vec_duplicate_p (op))));
}
static inline bool
satisfies_constraint_Z0 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 110 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(ival == 0xffffffff));
}
static inline bool
satisfies_constraint_Z1 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 115 "../../gcc-10.2.1-20200826/gcc/config/tilegx/constraints.md"
(ival == (HOST_WIDE_INT)0xffffffff00000000LL));
}
#endif /* tm-constrs.h */
